<?php
/*
	Copyright(c) 2010 Shift Tech Inc. All Rights Reserved.
 	http://www.shift-tech.jp/
*/

require_once (LIB_PATH.'/common/unitCommon.php');
/*
DROP TABLE IF EXISTS unit_btxt CASCADE;
CREATE TABLE unit_btxt (
	pageu_code		integer,			--ユニット配列順序における登録番号
	btxt_text		text,				--テキスト
	bg_color		smallint default 0,	--背景色　0：なし　1：あり
	bdr_type		smallint default 0,	--枠線　0：なし　1：実線　2：点線
	btm_padding		smallint default 2,	--下方スペース　0:なし　1：狭　2：標準　3：広
	primary key (pageu_code)
);

DROP TABLE IF EXISTS unit_btxt_tmp CASCADE;
CREATE TABLE unit_btxt_tmp (
	pageu_code		integer,			--ユニット配列順序における登録番号
	btxt_text		text,				--テキスト
	bg_color		smallint default 0,	--背景色　0：なし　1：あり
	bdr_type		smallint default 0,	--枠線　0：なし　1：実線　2：点線
	btm_padding		smallint default 2,	--下方スペース　0:なし　1：狭　2：標準　3：広
	primary key (pageu_code)
);
*/
class extVideo extends unitCommon
{
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "extunit_video"; 			//公開用テーブル名
	var $_tmptable = "extunit_video_tmp";	//下書き用テーブル名
	var $columns = array(
					array("column"=>"pageu_code","conv"=>"n","tags"=>false),	//ユニット登録コード
					array("column"=>"vid_url","conv"=>"KV","tags"=>false),		//テキスト
					array("column"=>"vid_title_flg","conv"=>"n","tags"=>false),		//テキスト
					array("column"=>"vid_desc_flg","conv"=>"n","tags"=>false),		//テキスト
					array("column"=>"vid_author_flg","conv"=>"n","tags"=>false),		//テキスト
					array("column"=>"vid_auto_flg","conv"=>"n","tags"=>false),		//テキスト
					array("column"=>"vid_loop_flg","conv"=>"n","tags"=>false),		//テキスト
          array("column"=>"apikey","conv"=>"a","tags"=>false),		//apikey
					array("column"=>"bg_color","conv"=>"n","tags"=>false),		//背景色
					array("column"=>"bdr_type","conv"=>"n","tags"=>false),		//枠線
					array("column"=>"btm_padding","conv"=>"n","tags"=>false),		//下方スペース
					array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),		//背景色
					array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),		//枠線
					array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),		//下方スペース
					array("column"=>"use_sp_flg","conv"=>"n","tags"=>false)		//スマホ表示
					);
	var $api = array(
		'youtube'=>'https://www.googleapis.com/youtube/v3/videos/'
		,'vimeo'=>'http://vimeo.com/api/oembed.xml'
	);

	function extVideo()
	{
		$this->__construct();
	}

	function __construct()
	{
		unitCommon::__construct();
	}
	//-----------------

	//出力データセット処理（必須）
	function setDisplayData() {
		$this->data = $this->getDetail();
		if(function_exists('curl_init')){
			if($this->data){
				if(defined("SP_FLG") && SP_FLG==SP_FLG_CODE){
					if(is_numeric($this->data["bg_color_sp"])) $this->data["bg_color"] = $this->data["bg_color_sp"];
					if(is_numeric($this->data["bdr_type_sp"])) $this->data["bdr_type"] = $this->data["bdr_type_sp"];
					if(is_numeric($this->data["btm_padding_sp"])) $this->data["btm_padding"] = $this->data["btm_padding_sp"];
				}
				$this->data["video"] = $this->getVideo($this->data["vid_url"]);
			}
		}else{
			$this->data["video"]["ERROR"] = "お使いのサーバーではcURLが使用出来ない為このユニットは使用出来ません。";
		}

		//ユニット編集時かどうかの判定用
		if(isset($_POST["unit_code"]) || $_POST['mode']=='add'){
			$this->_view->assign('isEdited', true);
		}

		return $this->data;
	}

	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
		$sql = "select * from ".$this->getTbl()." where pageu_code = ?";
		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);
			if ($result) {
				$rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
			}
		}
		return $rtn;
	}

	function getVideo($u){
		$k = "youtube";
		if(preg_match("/https?:\/\/vimeo.com\/.*/", $u)){
			$k = "vimeo";
		}

		if($k == "youtube"){
			return $this->getYoutube($u);
		}

		if($k == "vimeo"){
			return $this->getVimeo($u);
		}
		return array("ERROR"=>"動画が見つかりませんでした。");
	}

	function getYoutube($u){
		$videoId = array_pop(explode("/", $u));
    if(isset($this->data["apikey"]) && $this->data["apikey"]!=""){
      $api_url=$this->api["youtube"]."?part=snippet,contentDetails,player&key=".$this->data["apikey"]."&id=".$videoId;
      if(function_exists('curl_init') && function_exists('json_decode')){
        $ch = curl_init($api_url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($ch);
        curl_close($ch);
      }else{
        if(!ini_get("allow_url_fopen")){
          return array("ERROR"=>"ご使用のサーバーでは下記要件を満たしていない為動画APIが使用出来ません。<br /><br />
１．curlが使用出来る事、又はallow_url_fopenの設定がONとなっている事。<br />
２．curlを使用の場合でYouTubeを使用する際はPHP5.2以上必須となります。<br />
<br />
上記を満たして頂くか、YouTubeを使用いただき、APIキーを未設定でお試しください。");
        }
        $response = file_get_contents($api_url);
      }
      $result = json_decode($response);
      
      if($result==NULL || $result->error){
        return array("ERROR"=>"動画の取得に失敗しました。");
      }
    }

    $item = $result->items[0];
		$data = array();

		$data["type"] = "youtube";
		$data["title"] = $item->snippet->title;
		$data["description"] = $item->snippet->description;

    $data["player"] = $item->player->embedHtml;
    $data["url"] = "//www.youtube.com/embed/{$videoId}?wmode=transparent";
    if($this->data["vid_auto_flg"]){
			$data["url"] .="&amp;autoplay=1";
		}
		if($this->data["vid_loop_flg"]){
			$data["url"] .="&amp;loop=1&amp;playlist={$videoId}";
		}
    $thumbnail = (array)$item->snippet->thumbnails;
    $thumbnail = array_pop($thumbnail);
    if($thumbnail){
      $data["thumbnail"][0]["url"] = $thumbnail->url;
      $data["thumbnail"][0]["width"] = $thumbnail->width;
      $data["thumbnail"][0]["height"] = $thumbnail->height;
    }else{
      $data["thumbnail"][0]["width"] = 640;
      $data["thumbnail"][0]["height"] = 480;
    }
		$data["videoId"] = $videoId;

		return $data;
	}

	function getVimeo($u){
		$ch = curl_init($this->api["vimeo"]."?url=".$u);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 10);
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
		$xml = curl_exec($ch);
		curl_close($ch);

		if($xml===false){
			return array("ERROR"=>"vimeoへの接続に失敗しました。");
		}

		include_once("XML/Unserializer.php");
		$options = array(
		  XML_UNSERIALIZER_OPTION_ATTRIBUTES_PARSE => 'parseAttributes'
		);
		$unserializer = new XML_Unserializer($options);
		$unserializer->unserialize($xml);
		$result = $unserializer->getUnserializedData();

		if(PEAR::isError($result)){
			return array("ERROR"=>"動画の取得に失敗しました。");
		}
		$data = array();
		$data["type"] = "vimeo";
		$data["title"] = $result["title"];
		$data["description"] = $result["description"];
		$data["author_name"] = $result["author_name"];
		$data["author_url"] = $result["author_url"];
		$data["player"] = str_replace("<iframe ", "<iframe id=\"bVideo{$this->_pageu_code}\" ", $result["html"]);
		preg_match('/src="([\S\s]*?)"/',$data["player"], $match);
		$src = $match[1]."?wmode=transparent";
		if($this->data["vid_auto_flg"]){
			$src.="&amp;autoplay=1";
		}
		if($this->data["vid_loop_flg"]){
			$src.="&amp;loop=1";
		}
		$data["player"] = str_replace($match[1], $src, $data["player"]);

		$data["width"] = $result["width"];
		$data["height"] = $result["height"];
		$data["thumbnail"] = array(
			array(
				"url"=>$result["thumbnail_url"]
				,"width"=>$result["thumbnail_width"]
				,"height"=>$result["thumbnail_height"]
			)
		);
		$data["videoId"] = $result["video_id"];
		$duration = $result["duration"];
		$min = floor($duration/60);
		$sec = $duration - $min*60;
		$data["duration"] = array(
			"minute" => $min."分".$sec."秒"
			,"seconds" => $duration
		);
		return $data;
	}


	function setDefault()
	{
		$this->_form->setDefaults($this->getDetail());
	}

	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
		$this->_form->addElement('text','vid_url', null, array('id'=>'vid_url','rows'=>10));
		$this->_form->addElement('advcheckbox','vid_title_flg', null, _gettext('B_P00942'), array('id'=>'vid_title_flg'), array(0,1));
		$this->_form->addElement('advcheckbox','vid_desc_flg', null, _gettext('B_P00942'), array('id'=>'vid_desc_flg'), array(0,1));
		$this->_form->addElement('advcheckbox','vid_author_flg', null, _gettext('B_P00942'), array('id'=>'vid_author_flg'), array(0,1));
		$this->_form->addElement('advcheckbox','vid_auto_flg', null, _gettext('B_P00944'), array('id'=>'vid_auto_flg'), array(0,1));
		$this->_form->addElement('advcheckbox','vid_loop_flg', null, _gettext('B_P00945'), array('id'=>'vid_loop_flg'), array(0,1));
    $this->_form->addElement('text','apikey', null, array('id'=>'apikey','maxlength'=>255));
	}

	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings(_gettext('B_P00472'),'');
		$this->_form->addRule('pageu_code',_gettext('B_P00643'),'required',null,$this->erchk);
		$this->_form->addRule('vid_url',_gettext('B_P00210'),'required',null,$this->erchk);
	}

	function check_br($val){
		return !($val === "<br />");
	}

	//データ下書き保存処理
	function doSave($post)
	{
		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			} else {
				$record[$val["column"]] = null;
			}
		}

		//既存データがあるか確認
		$old_data = $this->getDetail();
		$this->db->query('BEGIN');
		//保存処理開始
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return _gettext('B_P00209');
			}
		} else { //新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return _gettext('B_P00209');
			}
		}
		$this->db->query('COMMIT');
		return null;
	}
}


?>